﻿#include <iostream>

using namespace std;

typedef int Elemtipus;

class MultiHalmaz {
    
	static const Elemtipus minelem = -50; //Min'Elemtipus
	static const Elemtipus maxelem = 50; //Max'Elemtipus
	int n; //Elemszam
	int elemek[maxelem - minelem + 1];//A halmaz elemeit tartalmazo tomb
	
  public: 
	
    void beolvasas() {
		cerr << "A multihalmaz elemszama: ";
		cin >> n;
		ures();
        for (int i = 1; i <= n; i++) {
			cerr << "Ird be a(z) " << i << ". elemet!" << endl;
			Elemtipus e;
			cin >> e;
			cerr << "Ird be a(z) " << i << ". elem darabszamat!" << endl;
			int db;
			cin >> db;
			elemek[e - minelem] = db; //Indexeltolas
        }
    }

    void kiiras() {
        cout << "A halmaz elemei es darabszamuk: " << endl;
        for (Elemtipus i = minelem; i <= maxelem; i++) {
            if (elemek[i - minelem] > 0) {
                cout << i << " " << elemek[i - minelem] << endl;
            }
        }
		cout << endl;
    }

    void ures() {
        for (Elemtipus i = minelem; i <= maxelem; i++) {
            elemek[i - minelem] = 0;
        }
    }

    bool uresE() {
        Elemtipus i = minelem;
        while(i <= maxelem && !eleme(i)) {
            i++;
        }
        return i > maxelem;
    }

    void multiHalmazba(const Elemtipus& e) {
        elemek[e - minelem]++;
    }

    void multiHalmazbol(const Elemtipus& e) {
        if (eleme(e)) {
            elemek[e - minelem]--;
        }
    }

    bool eleme(const Elemtipus& e) {
        return elemek[e - minelem] > 0;
    }

    int multiplicitas(const Elemtipus& e) {
        return elemek[e - minelem];
    }

    bool resze(const MultiHalmaz& masik) {
        Elemtipus i = minelem;
        while (i <= maxelem && elemek[i - minelem] <= masik.elemek[i - minelem]) {
            i++;
        }
        return i > maxelem;
    }

    Elemtipus min(const Elemtipus& a, const Elemtipus& b) {
        if (a < b) {
            return a;
        } else {
            return b;
        }
    }

    Elemtipus max(const Elemtipus& a, const Elemtipus& b) {
        if (a > b) {
            return a;
        } else {
            return b;
        }
    }

    MultiHalmaz unio(const MultiHalmaz& masik) {
        MultiHalmaz uniohalmaz;
        for (Elemtipus i = minelem; i <= maxelem; i++) {
            uniohalmaz.elemek[i - minelem] = elemek[i - minelem] + masik.elemek[i - minelem];
        }
        return uniohalmaz;
    }

    MultiHalmaz metszet(const MultiHalmaz& masik) {
        MultiHalmaz metszethalmaz;
        for (Elemtipus i = minelem; i <= maxelem; i++) {
            metszethalmaz.elemek[i - minelem] = min(elemek[i - minelem], masik.elemek[i - minelem]);
        }
        return metszethalmaz;
    }

    MultiHalmaz maximum(const MultiHalmaz& masik) {
        MultiHalmaz maximumhalmaz;
        for (Elemtipus i = minelem; i <= maxelem; i++) {
            maximumhalmaz.elemek[i - minelem] = max(elemek[i - minelem], masik.elemek[i - minelem]);
        }
        return maximumhalmaz;
    }

    MultiHalmaz kulonbseg(const MultiHalmaz& masik) {
        MultiHalmaz kulonbseghalmaz;
        for (Elemtipus i = minelem; i <= maxelem; i++) {
            kulonbseghalmaz.elemek[i - minelem] = max(elemek[i - minelem] - masik.elemek[i - minelem], 0);
        }
        return kulonbseghalmaz;
    }

    //Unió, Metszet, Maximum, Kulonbseg operatorokkal
    friend MultiHalmaz operator+(const MultiHalmaz& a, const MultiHalmaz& b) {
        MultiHalmaz uniohalmaz;
        for (Elemtipus i = minelem; i <= maxelem; i++) {
            uniohalmaz.elemek[i - minelem] = a.elemek[i - minelem] + b.elemek[i - minelem];
        }
        return uniohalmaz;
    }

    friend MultiHalmaz operator*(const MultiHalmaz& a, const MultiHalmaz& b) {
        MultiHalmaz metszethalmaz;
        for (Elemtipus i = minelem; i <= maxelem; i++) {
            metszethalmaz.elemek[i - minelem] = metszethalmaz.min(a.elemek[i - minelem], b.elemek[i - minelem]);
        }
        return metszethalmaz;
    }

    friend MultiHalmaz operator/(const MultiHalmaz& a, const MultiHalmaz& b) {
        MultiHalmaz maximumhalmaz;
        for (Elemtipus i = minelem; i <= maxelem; i++) {
            maximumhalmaz.elemek[i - minelem] = maximumhalmaz.max(a.elemek[i - minelem], b.elemek[i - minelem]);
        }
        return maximumhalmaz;
    }

    friend MultiHalmaz operator-(const MultiHalmaz& a, const MultiHalmaz& b) {
        MultiHalmaz kulonbseghalmaz;
        for (Elemtipus i = minelem; i <= maxelem; i++) {
            kulonbseghalmaz.elemek[i - minelem] = kulonbseghalmaz.max(a.elemek[i - minelem] - b.elemek[i - minelem], 0);
        }
        return kulonbseghalmaz;
    }
};

int main() {
	MultiHalmaz h1;
    h1.beolvasas();
    h1.kiiras();
    MultiHalmaz h2;
    h2.beolvasas();
    h2.kiiras();
    //h1.unió(h2).kiiras();
    (h1 + h2).kiiras();
    //h1.metszet(h2).kiiras();
    (h1 * h2).kiiras();
    //h1.maximum(h2).kiiras();
    (h1 / h2).kiiras();
    //h1.kulonbseg(h2).kiiras();
    (h1 - h2).kiiras();
			
	return 0;
}
