//package sablon;

import java.io.IOException;
import java.lang.Math;
import java.io.PrintStream;

import mester.IO;


public class feladat {

    public feladat() {
    }

    static final int MaxN = 100;
	
	class Multihalmaz {
        private int[] elem; // ElemTipus-sal indexelünk Min'ElemTipus=0; Max'ElemTipus=MaxN-1; érték = az adott elem darabszáma

		public int[] getElem() { // ElemTipus
			return elem;
		}
		
		public Multihalmaz() {
			elem=new int[MaxN]; // Elemtipus
			Ures();
		}
		
		public void Beolvasas(IO io) throws IOException {
			int N = io.nextInt();
			for (int i=0;i<N;i++) {
				int e=io.nextInt();
				elem[e]=io.nextInt();
			}
		}
		
		public void Kiiras(IO io) throws IOException {
			for (int i=0;i<MaxN;i++) {
				if (elem[i]>0) {
					io.writeLn(i+"("+elem[i]+")");
				}
			}
		}
		
		public void Ures() {
			for (int i=0;i<MaxN;i++) {
				elem[i]=0;
			}
		}
		
		public boolean UresE() {
			int i=0;
			while ((i<MaxN) && (!Eleme(i))) {
				i++;
			}
			return (i>=MaxN);
		}
		
		public void Multihalmazba(int e) { // Elemtipus
			elem[e]++;
		}
		
		public void Multihalmazbol(int e) { // Elemtipus
			if (elem[e]>0) {
				elem[e]--;
			}
		}
		
		public boolean Eleme(int e) { // Elemtipus
			return (elem[e]>0);
		}
  
		public boolean Resze(Multihalmaz masik) {
			int i=0;
			while ((i<MaxN) && masik.Eleme(elem[i])) {
				i++;
			}
			return (i>=MaxN);
		}
		
		public int multiplicitas(int e){
			return elem[e];
		}
		
		public boolean resze(Multihalmaz masik) {
			int i=0;
			while ((i<MaxN) && (elem[i]<=masik.getElem()[i])) {
				i++;
			}
			return (i>=MaxN);			
		}
		  
		public Multihalmaz Metszet(Multihalmaz masik) {
			Multihalmaz h=new Multihalmaz();
			for (int i=0;i<MaxN;i++) {
				h.elem[i]=Math.min(elem[i],masik.getElem()[i]);
			}
			return h;
		}
		
		public Multihalmaz Unio(Multihalmaz masik) {
			Multihalmaz h=new Multihalmaz();
			for (int i=0;i<MaxN;i++) {
				h.elem[i]=elem[i]+masik.getElem()[i];
			}
			return h;
		}
  
		public Multihalmaz Maximum(Multihalmaz masik) {
			Multihalmaz h=new Multihalmaz();
			for (int i=0;i<MaxN;i++) {
				h.elem[i]=Math.max(elem[i],masik.getElem()[i]);
			}
			return h;
		}

		public Multihalmaz Kulonbseg(Multihalmaz masik) {
			Multihalmaz h=new Multihalmaz();
			for (int i=0;i<MaxN;i++) {
				h.elem[i]=Math.max(elem[i]-masik.getElem()[i],0);
			}
			return h;
		}
		
	}	
   
    public void run() throws Exception {
        IO io = new IO();

		Multihalmaz h1=new Multihalmaz();
		h1.Beolvasas(io);
		System.err.println("A H1 halmaz elemei: ---------------------------------");
		h1.Kiiras(io);
		Multihalmaz h2=new Multihalmaz();
		System.err.println("Kerem a H2 halmazt: ---------------------------------");
		h2.Beolvasas(io);
		System.err.println("A H2 halmaz elemei: ---------------------------------");
		h2.Kiiras(io);
		System.err.println("Unio(H1,H2): ----------------------------------------");
		h1.Unio(h2).Kiiras(io);
		System.err.println("Metszet(H1,H2): -------------------------------------");
		h1.Metszet(h2).Kiiras(io);
		System.err.println("Maximum(H1,H2): -------------------------------------");
		h1.Maximum(h2).Kiiras(io);
		System.err.println("H1\\H2: ----------------------------------------------");
		h1.Kulonbseg(h2).Kiiras(io);

        io.close();
    }
	
	public static void main(String[] args) throws Exception {
		new feladat().run();
	}

}