Program Halmaz_Megvalositas2;
(*
  Feladat: A halmaz típuskonstrukció és egy próbaprogram implementálása.
  *        A halmaz műveleteket nem kell önellenőrzéssel ellátni!
  * 
  Megjegyzés: a műveletek megvalósítása az operátor fogalomra vezetendő vissza.
  * 
*)
  {$mode objfpc}{$h+}
  Const//Elemtípus "paraméterei":
    MinElem=-50;
    MaxElem=+50;
  Type
    Elemtipus=MinElem..MaxElem;
  //Elemtipus szükséges függvényei:
  Function Min(Const x,y:Elemtipus):Elemtipus;
  Begin
    If x<y then Min:=x else Min:=y;
  End;
  Function Max(Const x,y:Elemtipus):Elemtipus;
  Begin
    If x>y then Max:=x else Max:=y;
  End;

  //A multihalmaz reprezentálása: --------------------------------------
  Type
    Multihalmaz=Array [Elemtipus] of Integer;
  //A multihalmaz műveletek implementálása: ----------------------------
  Procedure Beolvasas(Var h:Multihalmaz{Elemtipus});
    Var
      n,i,d:Integer;
      e:Elemtipus;
  Begin
    //A felhasználónak szánt tájékoztató üzenetek az StrErr csatornára írandók!
    //Például a kérdések:
    Write(StdErr,'A multihalmazban legalabb egy peldanyban elofordulo ertekek szama (0..',MaxElem-MinElem+1,'):');
    //A bemenetet nem ellenőrizzük sem szintaktikai, sem szemantikai szempontból.
    Readln(n);//0<=n<=MaxElem-MinElem+1
    For i:=1 to n do
    Begin
      Write(StdErr,i:3,'. ertek [',MinElem,',',MaxElem,'] es darabszama (>0):'); 
      Readln(e,d); h[e]:=d;
    End;
  End;

  Procedure Kiiras(Const h:Multihalmaz{Elemtipus});
    Var
      i:Elemtipus;
  Begin
    For i:=MinElem to MaxElem do
    Begin
      If h[i]>0 then
      Begin
        Writeln(StdErr,' ertek (db):'); Writeln(i:3,'(',h[i],')'); 
      End;
    End;
  End;
  
  Procedure Ures(Var h:Multihalmaz{Elemtipus});
    Var
      i:Elemtipus;
  Begin
    For i:=MinElem to MaxElem do
    Begin
      h[i]:=0;
    End;
  End;
  
  Function UresE(Const h:Multihalmaz{Elemtipus}):Boolean;
    Var
      i:Elemtipus;
  Begin
    i:=MinElem;
    While (i<=MaxElem) and not (h[i]>0) do
    Begin
      Inc(i);
    End;
    UresE:=i>MaxElem;
  End;
  
  Procedure Multihalmazba(Var h:Multihalmaz{Elemtipus}; Const e:Elemtipus);
  Begin
    Inc(h[e]);
  End;
  
  Procedure Multihalmazbol(Var h:Multihalmaz{Elemtipus}; Const e:Elemtipus);
  Begin
    If h[e]>0 then Dec(h[e]);
  End;
  
  Operator in(Const e:Elemtipus; Const h:Multihalmaz{Elemtipus}) Eleme:Boolean;
  //Function Eleme(Const e:Elemtipus; Const h:Multihalmaz{Elemtipus}):Boolean;
  Begin
    Eleme:=h[e]>0;
  End;
  
  Function Multiplicitas(Const h:Multihalmaz{Elemtipus}; Const e:Elemtipus):Integer;
  Begin
    Multiplicitas:=h[e];
  End;
  
  Operator <(Const h1,h2:Multihalmaz{Elemtipus}) Resze:Boolean;
  //Function Resze(Const h1,h2:Multihalmaz{Elemtipus}):Boolean;
    Var
      i:Elemtipus;
  Begin
    i:=MinElem;
    While (i<=MaxElem) and (h1[i]<=h2[i]) do
    Begin
      Inc(i);
    End;
    Resze:=i>MaxElem;
  End;
  
  Operator *(Const h1,h2:Multihalmaz{Elemtipus}) Metszet:Multihalmaz{Elemtipus};
  //Function Metszet(Const h1,h2:Multihalmaz{Elemtipus}):Multihalmaz{Elemtipus};
    Var
      i:Elemtipus;
      h:Multihalmaz{Elemtípus};
  Begin
    For i:=MinElem to MaxElem do
    Begin
      h[i]:=min(h1[i],h2[i]);
    End;
    Metszet:=h;
  End;
  
  Operator +(Const h1,h2:Multihalmaz{Elemtipus}) Unio:Multihalmaz{Elemtipus};
  //Function Unio(Const h1,h2:Multihalmaz{Elemtipus}):Multihalmaz{Elemtipus};
    Var
      i:Elemtipus;
      h:Multihalmaz{Elemtípus};
  Begin
    For i:=MinElem to MaxElem do
    Begin
      h[i]:=h1[i]+h2[i];
    End;
    Unio:=h;
  End;
  
  Function Maximum(Const h1,h2:Multihalmaz{Elemtipus}):Multihalmaz{Elemtipus};
    Var
      i:Elemtipus;
      h:Multihalmaz{Elemtípus};
  Begin
    For i:=MinElem to MaxElem do
    Begin
      h[i]:=Max(h1[i],h2[i]);
    End;
    Maximum:=h;
  End;
  
  Operator -(Const h1,h2:Multihalmaz{Elemtipus}) Kulonbseg:Multihalmaz{Elemtipus};
  //Function Kulonbseg(Const h1,h2:Multihalmaz{Elemtipus}):Multihalmaz{Elemtipus};
    Var
      i:Elemtipus;
      h:Multihalmaz{Elemtípus};
  Begin
    For i:=MinElem to MaxElem do
    Begin
      h[i]:=Max(h1[i]-h2[i],0);
    End;
    Kulonbseg:=h;
  End;
  
  //A próba program: ---------------------------------------------------
  Var
    H1,H2:Multihalmaz{Elemtipus};

Begin
  Writeln(StdErr,'Kerem a H1 halmazt: ---------------------------------');
  Beolvasas(H1);
  Writeln(StdErr,'A H1 halmaz elemei: ---------------------------------');
  Kiiras(H1);
  Writeln(StdErr,'Kerem a H2 halmazt: ---------------------------------');
  Beolvasas(H2);
  Writeln(StdErr,'A H2 halmaz elemei: ---------------------------------');
  Kiiras(H2);
  Writeln(StdErr,'Unio(H1,H2): ----------------------------------------');
  Kiiras(H1+H2);//Kiiras(Unio(H1,H2));
  Writeln(StdErr,'Metszet(H1,H2): -------------------------------------');
  Kiiras(H1*H2);//Kiiras(Metszet(H1,H2));
  Writeln(StdErr,'Maximum(H1,H2): -------------------------------------');
  Kiiras(Maximum(H1,H2));
  Writeln(StdErr,'H1\H2: ----------------------------------------------');
  Kiiras(H1-H2);//Kiiras(Kulonbseg(H1,H2));
End.
