﻿'''
Halmaztípus megvalósítása
A jelen megvalósítás az algoritmust tükrözi, más megoldások is létezhetnek
'''
import sys
from copy import deepcopy

#az implementációhoz létrehozunk egy Halmaz osztályt, amelyben szótár elemeket használunk. elemérték az elemérték, érték pedig a multiplicitás 
#az elemtípus most szöveg - ennek rögzítése a beolvasásánál és kiírásnál szükséges csak
#ha más elemtípussal dolgozunk - változtatni itt kell

class MultiHalmaz:
    def __init__(self):         # a self mindig az aktuális objektumra vonatkozik
        self.h={}                 #nincs szükség a darabszám tárolására  

    def Üres(self):
       self.h={} #ürítjük a szótárt
                             
    def Üres_e(self):
        return len(self.h)==0

    def Halmazba(self,e):
        if e not in self.h.keys():
            self.h[e]=1
        else:
            self.h[e]+=1
            
    def Halmazból(self,e):

        if self.h[e]==1:
                
            self.h.remove(e) #létezik törlés művelet
        else:
            self.h[e]-=1 #a multiplicitást csökkentjük
            
    def Eleme(self,e):
        return e in self.h.keys()

    def Multiplicitás(self,e): 
        return self.h[e];

    def Része(self, másik): #az első paraméterben megadott halmaz része-e a másodiknak, multiplicitást itt nem figyeljük
        for elemérték in  self.h.keys():
            if elemérték not in másik.h.keys():
                return False
        return True

    def Max(self,b):
        c=deepcopy(self)
        
        for elemérték  in b.h.keys():
            bmult=MultiHalmaz.Multiplicitás(b,elemérték)
            if not MultiHalmaz.Eleme(c,elemérték):
                c.h[elemérték]=bmult
            else:
                amult=c.h[elemérték]
                
                if amult>bmult:
                    maxmult=amult
                else:
                    maxmult=bmult
                
                c.h[elemérték]=maxmult
            
        return c               

    def Min(self,b):
        c=deepcopy(self)
        for elemérték  in b.h.keys():
            bmult=b.h[elemérték]
            if elemérték not in c.h.keys():
                c.h[elemérték]=bmult
            else:
                amult=c.h[elemérték]
                if amult<bmult:
                    minmult=amult
                else:
                    minmult=bmult
                c.h[elemérték]=minmult
        
          
        return c       
        
    def __add__(self,másik): #a + operátor felülírása
        
        unióhalmaz=deepcopy(self) #Másolatot készít 
        
        for elemérték in másik.h.keys():                               
            if elemérték in unióhalmaz.h.keys():
                unióhalmaz.h[elemérték]+=másik.h[elemérték]
            else:
                unióhalmaz.h[elemérték]=másik.h[elemérték]
        
        return unióhalmaz
        
    def __mul__(self, másik): #a * operátor felülírása
        metszethalmaz = MultiHalmaz()
        for elemérték in másik.h.keys():                               
            if elemérték in self.h.keys():
                metszethalmaz.h[elemérték]=min(self.h[elemérték],másik.h[elemérték])
            
        return metszethalmaz;

    def __sub__(self, másik): #a - operátor felülírása
        különbséghalmaz=MultiHalmaz()
        for elemérték in self.h.keys():                               
            if elemérték in másik.h.keys():
                if self.h[elemérték]-másik.h[elemérték]>0:
                    különbséghalmaz.h[elemérték]=self.h[elemérték]-másik.h[elemérték]
            else:
                különbséghalmaz.h[elemérték]=self.h[elemérték]
                            
        return különbséghalmaz

def Beolvasás(halmaz):
    sys.stderr.write("A halmaz elemszáma: ")
    N=int(input())
    for i in range(N):
        sys.stderr.write("Írd be a(z) "+str(i+1)+". elemet!")
        sor=input().split() #egy sorban várja az értéket és a multiplicitást
        halmaz.h[sor[0]]=int(sor[1])
        
def Kiírás(halmaz):
    print("A halmaz elemszáma: "+str(len(halmaz.h)))
    if len(halmaz.h)>0:
        for elemérték in halmaz.h.keys():
           print(elemérték+" "+str(halmaz.h[elemérték]),end=", ") #most szöveg típusú, itt kellene változtatni más típusnál
        print()
               

h1 = MultiHalmaz()
Beolvasás(h1)
Kiírás(h1)

h2=MultiHalmaz()
Beolvasás(h2)
Kiírás(h2)

sys.stderr.write("Része\n")
if (MultiHalmaz.Része(h1,h2)):
    print("Része")
else:
    print("Nem része")

sys.stderr.write("Max\n")
Kiírás(MultiHalmaz.Max(h1,h2))
sys.stderr.write("Min\n")
Kiírás(MultiHalmaz.Min(h1,h2))

sys.stderr.write("Unió\n") 
Kiírás(h1+h2)  #Unió
sys.stderr.write("Metszet\n")
Kiírás(h1*h2)  #Metszet
sys.stderr.write("Különbség\n")
Kiírás(h1-h2)  #Különbség
